local Decliner = CreateFrame('frame', 'Decliner')

declinervars = {
	saved = false,
	defaults = {
		duel = {
			enabled = true,
			tell = false,
			guild = false,
			friend = false,
			bnet = false,
			message = false,
		},
		guild = {
			enabled = true,
			tell = false,
			friend = false,
			bnet = false,
			message = false,
		},
		group = {
			enabled = true,
			tell = false,
			guild = false,
			friend = false,
			bnet = false,
			message = false,
		},
		chart = {
			enabled = true,
			tell = false,
			guild = false,
			friend = false,
			bnet = false,
			message = false,
		},
		trade = {
			enabled = true,
			tell = false,
			guild = false,
			friend = false,
			bnet = false,
			message = false,
		},
	},
	opt = {
		duel = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
		guild = {
			enabled,
			tell,
			friend,
			bnet,
			message,
		},
		group = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
		chart = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
		trade = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
	},
	temp = {
		duel = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
		guild = {
			enabled,
			tell,
			friend,
			bnet,
			message,
		},
		group = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
		chart = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
		trade = {
			enabled,
			tell,
			guild,
			friend,
			bnet,
			message,
		},
	},
}

declinersavedvars = {}
local addon
local blockGIs
local blockTrades
local boolean1
local boolean2
local guild
local lasttell
local message
local name
local namerealm
local oldSFX
local panel
local pattern
local tooltip
local tradeinitiated
local value
local xloc
local yloc

local dclLoadMsg = "loaded"
local dclDuelMsg = "duel request from %s"
local dclGuildMsg = "guild invite from %s of <%s>"
local dclGroupMsg = "group invite from %s"
local dclChartMsg = "%s petition from %s"
local dclTradeMsg = "trade request from %s"
do
	local L = GetLocale()
	if L == 'deDE' then
		dclLoadMsg = "geladen"
		dclDuelMsg = "duell anfrage von %s"
		dclGuildMsg = "gilde einladen von %s von <%s>"
		dclGroupMsg = "gruppe einladen von %s"
		dclChartMsg = "%s petition von %s"
		dclTradeMsg = "handelsanfrage von %s"
	elseif L == 'esES' or L == 'esMX' then
		dclLoadMsg = "cargado"
		dclDuelMsg = "solicitud duelo de %s"
		dclGuildMsg = "gremio invitar a %s de <%s>"
		dclGroupMsg = "grupo invitar a %s"
		dclChartMsg = "%s peticin de %s"
		dclTradeMsg = "solicitud comercio de %s"
	elseif L == 'frFR' then
		dclLoadMsg = "charg"
		dclDuelMsg = "demande de duel de %s"
		dclGuildMsg = "inviter guilde de %s de <%s>"
		dclGroupMsg = "inviter groupe de %s"
		dclChartMsg = "%s ptition de %s"
		dclTradeMsg = "commerce demande de %s"
--
-- unable to paste these characters
--
--	elseif L == 'koKR' then
--		dclLoadMsg = ""
--		dclDuelMsg = ""
--		dclGuildMsg = ""
--		dclGroupMsg = ""
--		dclChartMsg = ""
--		dclTradeMsg = ""
--	elseif L == 'ruRU' then
--		dclLoadMsg = ""
--		dclDuelMsg = ""
--		dclGuildMsg = ""
--		dclGroupMsg = ""
--		dclChartMsg = ""
--		dclTradeMsg = ""
--	elseif L == 'zhCN' then
--		dclLoadMsg = ""
--		dclDuelMsg = ""
--		dclGuildMsg = ""
--		dclGroupMsg = ""
--		dclChartMsg = ""
--		dclTradeMsg = ""
--	elseif L == 'zhTW' then
--		dclLoadMsg = ""
--		dclDuelMsg = ""
--		dclGuildMsg = ""
--		dclGroupMsg = ""
--		dclChartMsg = ""
--		dclTradeMsg = ""
	end
end

function Decliner:Patterns(pattern)
	pattern = string.gsub(pattern, '%.', '')
	pattern = string.gsub(pattern, '%%%d?$?c', '')
	pattern = string.gsub(pattern, '%%%d?$?d', '')
	pattern = string.gsub(pattern, '%%%d?$?s', '')
	pattern = string.gsub(pattern, '%[.*%]', '')
	pattern = string.gsub(pattern, '|h', '')
	pattern = string.gsub(pattern, '|Hplayer:', '')
	pattern = string.gsub(pattern, '^%s', '')
	pattern = string.gsub(pattern, '%s$', '')
	return '.*'..pattern..'.*'
end -- credit to Phanx (SpamAway, but initially a pattern matching thread on WoWInterface)
local tradeinisysmsg = Decliner:Patterns(ERR_INITIATE_TRADE_S)
local duelsysmsg = Decliner:Patterns(DUEL_REQUESTED)
local guildsysmsg = Decliner:Patterns(ERR_INVITED_TO_GUILD_SSS)
local groupsysmsg = Decliner:Patterns(ERR_INVITED_TO_GROUP_SS)
--local chartsysmsg = Decliner:Patterns(PETITION?)
local tradesysmsg = Decliner:Patterns(ERR_TRADE_REQUEST_S)

--ERR_INITIATE_TRADE_S = "You have requested to trade with %s.";
--DUEL_REQUESTED = "%s has challenged you to a duel.";
--ERR_INVITED_TO_GUILD_SSS = "|Hplayer:%s|h[%s]|h invites you to join %s.";
--ERR_INVITED_TO_GROUP_SS = "|Hplayer:%s|h[%s]|h has invited you to join a group.";
--ERR_TRADE_REQUEST_S = "%s has requested to trade with you.";

function Decliner:ADDON_LOADED(addon)
	if addon == 'Decliner' then
		if declinersavedvars.saved then
			declinervars.opt = declinersavedvars
		else
			declinervars.opt = declinervars.defaults
			declinersavedvars = declinervars.opt
		end
		Decliner:Options()
		oldSFX = GetCVar('Sound_EnableSFX')
		Decliner:DisableGT()
		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Decliner |cffffff00v"..GetAddOnMetadata('Decliner', 'Version').." "..dclLoadMsg.."")
	end
end

function Decliner:CVAR_UPDATE(name, value)
	if name == 'ENABLE_SOUNDFX' then oldSFX = value end
end

function Decliner:CHAT_MSG_SYSTEM(message)
	if string.match(message, tradeinisysmsg) then
		tradeinitiated = true
	end
end

function Decliner:CHAT_MSG_WHISPER_INFORM(_, name)
	lasttell = Decliner:fullName(name)
end

function Decliner:DUEL_REQUESTED(name)
	SetCVar('Sound_EnableSFX', '0')
	StaticPopup_Hide('DUEL_REQUESTED')
	C_Timer.After(1, function() SetCVar('Sound_EnableSFX', oldSFX) end)
	namerealm = Decliner:fullName(name)
	if declinervars.opt.duel.enabled and ((lasttell ~= namerealm) or declinervars.opt.duel.tell) and (Decliner:isNotGuildie(namerealm) or declinervars.opt.duel.guild) and (Decliner:isNotFriend(namerealm) or declinervars.opt.duel.friend) and (Decliner:isNotBNFriend(namerealm) or declinervars.opt.duel.bnet) then
		CancelDuel()
		if not declinervars.opt.duel.message then
			local DuelMsg = string.format(dclDuelMsg, Decliner:localName(namerealm))
			Decliner:Print(DuelMsg)
		end
	else
		SetCVar('Sound_EnableSFX', oldSFX)
		StaticPopup_Show('DUEL_REQUESTED')
		PlaySoundKitID(880)
		local DuelMsg = string.format(DUEL_REQUESTED, Decliner:localName(namerealm))
		Decliner:Print(DuelMsg)
	end
end

function Decliner:GUILD_INVITE_REQUEST(name, guild)
	SetCVar('Sound_EnableSFX', '0')
	StaticPopupSpecial_Hide(GuildInviteFrame)
	C_Timer.After(1, function() SetCVar('Sound_EnableSFX', oldSFX) end)
	namerealm = Decliner:fullName(name)
	if declinervars.opt.guild.enabled and ((lasttell ~= namerealm) or declinervars.opt.guild.tell) and (Decliner:isNotFriend(namerealm) or declinervars.opt.guild.friend) and (Decliner:isNotBNFriend(namerealm) or declinervars.opt.guild.bnet) then
		DeclineGuild()
		if not declinervars.opt.guild.message then
			local GuildMsg = string.format(dclGuildMsg, Decliner:localName(namerealm), guild)
			Decliner:Print(GuildMsg)
		end
	else
		SetCVar('Sound_EnableSFX', oldSFX)
		StaticPopup_Show('DUEL_REQUESTED')
		PlaySoundKitID(888)
		local GuildMsg = string.format(ERR_INVITED_TO_GUILD_SSS, Decliner:localName(namerealm), guild)
		Decliner:Print(GuildMsg)
	end
end

function Decliner:PARTY_INVITE_REQUEST(name)
	SetCVar('Sound_EnableSFX', '0')
	StaticPopup_Hide('PARTY_INVITE')
	StaticPopup_Hide('PARTY_INVITE_XREALM')
	C_Timer.After(1, function() SetCVar('Sound_EnableSFX', oldSFX) end)
	namerealm = Decliner:fullName(name)
	if declinervars.opt.group.enabled and ((lasttell ~= namerealm) or declinervars.opt.group.tell) and (Decliner:isNotGuildie(namerealm) or declinervars.opt.group.guild) and (Decliner:isNotFriend(namerealm) or declinervars.opt.group.friend) and (Decliner:isNotBNFriend(namerealm) or declinervars.opt.group.bnet) then
		DeclineGroup()
		if not declinervars.opt.group.message then
			local GroupMsg = string.format(dclGroupMsg, Decliner:localName(namerealm))
			Decliner:Print(GroupMsg)
		end
	else
		SetCVar('Sound_EnableSFX', oldSFX)
		local toon, realm = namerealm:match('^(.*)%s*-%s*([^-]*)$')
		local myrealm = GetRealmName()
		local myrealm = myrealm:gsub('%s', '')
		if realm == myrealm then
			StaticPopup_Show('PARTY_INVITE')
		else
			StaticPopup_Show('PARTY_INVITE_XREALM')
		end
		PlaySoundKitID(880)
		local GroupMsg = string.format(ERR_INVITED_TO_GROUP_SS, Decliner:localName(namerealm))
		Decliner:Print(GroupMsg)
	end
end

function Decliner:PETITION_SHOW()
	SetCVar('Sound_EnableSFX', '0')
	HideUIPanel(PetitionFrame)
	C_Timer.After(1, function() SetCVar('Sound_EnableSFX', oldSFX) end)
	local ptype, _, _, _, name, isOriginator = GetPetitionInfo()
	namerealm = Decliner:fullName(name)
	if not isOriginator and declinervars.opt.chart.enabled and ((lasttell ~= namerealm) or declinervars.opt.chart.tell) and (Decliner:isNotGuildie(namerealm) or declinervars.opt.chart.guild) and (Decliner:isNotFriend(namerealm) or declinervars.opt.chart.friend) and (Decliner:isNotBNFriend(namerealm) or declinervars.opt.chart.bnet) then
		ClosePetition()
		if not declinervars.opt.chart.message then
			local ChartMsg = string.format(dclChartMsg, ptype, Decliner:localName(namerealm))
			Decliner:Print(ChartMsg)
		end
	else
		SetCVar('Sound_EnableSFX', oldSFX)
		StaticPopup_Show('DUEL_REQUESTED')
		PlaySoundKitID(875)
	end
end

function Decliner:TRADE_SHOW()
	SetCVar('Sound_EnableSFX', '0')
	HideUIPanel(TradeFrame)
	C_Timer.After(1, function() SetCVar('Sound_EnableSFX', oldSFX) end)
	local name, realm = UnitName('npc') -- credit to http://wowprogramming.com/forums/development/250 (and the hint next to 'npc' at http://wowprogramming.com/docs/api_types#unitID) since TRADE_SHOW doesn't pass a name
	if realm == nil then
		namerealm = Decliner:fullName(name)
	else
		namerealm = name..'-'..realm
	end
	if not tradeinitiated and declinervars.opt.trade.enabled and ((lasttell ~= namerealm) or declinervars.opt.trade.tell) and (Decliner:isNotGuildie(namerealm) or declinervars.opt.trade.guild) and (Decliner:isNotFriend(namerealm) or declinervars.opt.trade.friend) and (Decliner:isNotBNFriend(namerealm) or declinervars.opt.trade.bnet) then
		CloseTrade()
		if not declinervars.opt.trade.message then
			local TradeMsg = string.format(dclTradeMsg, Decliner:localName(namerealm))
			Decliner:Print(TradeMsg)
		end
	else
		SetCVar('Sound_EnableSFX', oldSFX)
		StaticPopup_Show('DUEL_REQUESTED')
		PlaySoundKitID(839)
		local TradeMsg = string.format(ERR_TRADE_REQUEST_S, Decliner:localName(namerealm))
		Decliner:Print(TradeMsg)
	end
end

function Decliner:TRADE_CLOSED()
	tradeinitiated = false
end

function Decliner:UI_INFO_MESSAGE(message)
	if (string.match(message, Decliner:Patterns(ERR_DUEL_CANCELLED)) and declinervars.opt.duel.enabled) or (string.match(message, Decliner:Patterns(ERR_TRADE_CANCELLED)) and declinervars.opt.trade.enabled) then
		UIErrorsFrame:Clear()
	end
end

function Decliner:PLAYER_LOGOUT()
	declinersavedvars = declinervars.opt
	declinersavedvars.saved = true
end

Decliner:RegisterEvent('ADDON_LOADED')
Decliner:RegisterEvent('CVAR_UPDATE')
Decliner:RegisterEvent('CHAT_MSG_SYSTEM')
Decliner:RegisterEvent('CHAT_MSG_WHISPER_INFORM')
Decliner:RegisterEvent('DUEL_REQUESTED')
Decliner:RegisterEvent('GUILD_INVITE_REQUEST')
Decliner:RegisterEvent('PARTY_INVITE_REQUEST')
Decliner:RegisterEvent('PETITION_SHOW')
Decliner:RegisterEvent('TRADE_SHOW')
Decliner:RegisterEvent('TRADE_CLOSED')
Decliner:RegisterEvent('UI_INFO_MESSAGE')
Decliner:RegisterEvent('PLAYER_LOGOUT')
Decliner:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)

function Decliner:localName(namerealm)
	local toon, realm = namerealm:match('^(.*)%s*-%s*([^-]*)$')
	local myrealm = GetRealmName()
	local myrealm = myrealm:gsub('%s', '')
	if realm == myrealm then
		return toon
	else
		return toon..'-'..realm
	end
end

function Decliner:fullName(name)
	local toon, realm = name:match('^(.*)%s*-%s*([^-]*)$')
	if not realm or #realm == 0 then
		toon = name
		realm = GetRealmName()
	end
	realm = realm:gsub('%s', '')
	return toon..'-'..realm
end -- credit to RaidBuffStatus

function Decliner:isNotGuildie(name)
	local _isNotGuildie = true
	if (IsInGuild()) then
		for i=1, GetNumGuildMembers() do
			local gname = GetGuildRosterInfo(i)
			if name == Decliner:fullName(gname) then
				_isNotGuildie = false
				return _isNotGuildie
			end
		end
	end
	return _isNotGuildie
end -- credit to Broker_AntiSocial

function Decliner:isNotFriend(name)
	local _isNotFriend = true
	for i=1, GetNumFriends() do
		local fname = GetFriendInfo(i)
		if name == Decliner:fullName(fname) then
			_isNotFriend = false
			return _isNotFriend
		end
	end
	return _isNotFriend
end -- credit to Broker_AntiSocial

function Decliner:isNotBNFriend(name)
	local _isNotBNFriend = true
	for i=1, BNGetNumFriends() do
		local _, _, _, _, _, _, client, isOnline = BNGetFriendInfo(i)
		if client == 'WoW' and isOnline then
			for j=1, BNGetNumFriendToons(i) do
				local _, toonName, _, realmName = BNGetFriendToonInfo(i, j)
				if name == toonName..'-'..realmName:gsub('%s', '') then
					_isNotBNFriend = false
					return _isNotBNFriend
				end
			end
		end
	end
	return _isNotBNFriend
end -- credit to RaidBuffStatus

function Decliner:Print(message)
	local channel = 'CHAT_MSG_SYSTEM'
 	for i=1, NUM_CHAT_WINDOWS do
		local chatframe = _G['ChatFrame'..i]
		if chatframe:IsEventRegistered(channel) then
			ChatFrame_MessageEventHandler(chatframe, channel, "|cffff0000Decliner: |r"..message, '', nil, '')
		end
	end
end -- credit to Jaliborc (Scrap)

ChatFrame_AddMessageEventFilter('CHAT_MSG_SYSTEM', function (_, _, message)
	if string.match(message, duelsysmsg) and declinervars.opt.duel.enabled then
		return true
	elseif string.match(message, guildsysmsg) and declinervars.opt.guild.enabled then
		return true
	elseif string.match(message, groupsysmsg) and declinervars.opt.group.enabled then
		return true
--	elseif string.match(message, chartsysmsg) and declinervars.opt.chart.enabled then
--		return true -- there's no system message for petitions
	elseif string.match(message, tradesysmsg) and declinervars.opt.trade.enabled then
		return true -- this doesn't fire, but it exists
	else return false
	end
end)

function Decliner:CreateText(xloc, yloc, text)
	local settext = Decliner_Panel:CreateFontString(nil, 'ARTWORK', 'GameFontNormalCenter')
	settext:SetPoint('TOPLEFT', xloc, yloc)
	settext:SetText(text)
	return settext
end

local checkboxnumber = 0
function Decliner:CreateCheckButton(xloc, yloc, tooltip)
	checkboxnumber = checkboxnumber + 1
	checkboxname = 'DeclinerCheckBoxGlobalName'..string.format('%02i', checkboxnumber)
	local checkbox = CreateFrame('CheckButton', checkboxname, Decliner_Panel, 'InterfaceOptionsCheckButtonTemplate')
	checkbox:SetPoint('TOPLEFT', xloc, yloc)
	checkbox:SetHitRectInsets(0, 0, 0, 0)
	checkbox.tooltipText = tooltip
	return checkbox
end -- credit to http://wow.gamepedia.com/UIOBJECT_CheckButton#Recommendation for this neat 'checkbutton factory' function that I also used to make CreateText above

function Decliner:Options()
	local Decliner_Panel = CreateFrame('frame', 'Decliner_Panel')
	Decliner_Panel.name = 'Decliner'
	InterfaceOptions_AddCategory(Decliner_Panel)
	DeclinerText01 = Decliner:CreateText(180, -60, "Duel")
	DeclinerText02 = Decliner:CreateText(180, -80, "Requests")
	DeclinerText03 = Decliner:CreateText(260, -60, "Guild")
	DeclinerText04 = Decliner:CreateText(260, -80, "Invites")
	DeclinerText05 = Decliner:CreateText(340, -60, "Group")
	DeclinerText06 = Decliner:CreateText(340, -80, "Invites")
	DeclinerText07 = Decliner:CreateText(420, -60, "Arena/Guild")
	DeclinerText08 = Decliner:CreateText(420, -80, "Petitions")
	DeclinerText09 = Decliner:CreateText(500, -60, "Trade")
	DeclinerText10 = Decliner:CreateText(500, -80, "Requests")
	DeclinerText11 = Decliner:CreateText(18, -110, "Enable declines")
	DeclinerCheckBox01 = Decliner:CreateCheckButton(180, -100, "Enable duel declines")
	DeclinerCheckBox02 = Decliner:CreateCheckButton(260, -100, "Enable guild invite declines")
	DeclinerCheckBox03 = Decliner:CreateCheckButton(340, -100, "Enable group invite declines")
	DeclinerCheckBox04 = Decliner:CreateCheckButton(420, -100, "Enable arena/guild petition declines")
	DeclinerCheckBox05 = Decliner:CreateCheckButton(500, -100, "Enable trade declines")
	DeclinerText12 = Decliner:CreateText(18, -190, "Last player whispered")
	DeclinerCheckBox06 = Decliner:CreateCheckButton(180, -180, "Decline duels from player you last whispered")
	DeclinerCheckBox07 = Decliner:CreateCheckButton(260, -180, "Decline guild invites from player you last whispered")
	DeclinerCheckBox08 = Decliner:CreateCheckButton(340, -180, "Decline group invites from player you last whispered")
	DeclinerCheckBox09 = Decliner:CreateCheckButton(420, -180, "Decline petitions from player you last whispered")
	DeclinerCheckBox10 = Decliner:CreateCheckButton(500, -180, "Decline trades from player you last whispered")
	DeclinerText13 = Decliner:CreateText(18, -270, "Guildmates")
	DeclinerCheckBox11 = Decliner:CreateCheckButton(180, -260, "Decline duels from guildmates")
	DeclinerCheckBox12 = Decliner:CreateCheckButton(260, -260, "This checkbox is only here because I didn't want an empty spot. You can't receive guild invites from guildmates.")
	DeclinerCheckBox12:SetChecked(false)
	DeclinerCheckBox13 = Decliner:CreateCheckButton(340, -260, "Decline group invites from guildmates")
	DeclinerCheckBox14 = Decliner:CreateCheckButton(420, -260, "Decline petitions from guildmates")
	DeclinerCheckBox15 = Decliner:CreateCheckButton(500, -260, "Decline trades from guildmates")
	DeclinerText14 = Decliner:CreateText(18, -350, "Friends")
	DeclinerCheckBox16 = Decliner:CreateCheckButton(180, -340, "Decline duels from friends")
	DeclinerCheckBox17 = Decliner:CreateCheckButton(260, -340, "Decline guild invites from friends")
	DeclinerCheckBox18 = Decliner:CreateCheckButton(340, -340, "Decline group invites from friends")
	DeclinerCheckBox19 = Decliner:CreateCheckButton(420, -340, "Decline petitions from friends")
	DeclinerCheckBox20 = Decliner:CreateCheckButton(500, -340, "Decline trades from friends")
	DeclinerText15 = Decliner:CreateText(18, -430, "RealID/Battletag")
	DeclinerCheckBox21 = Decliner:CreateCheckButton(180, -420, "Decline duels from RealID/Battletag friends")
	DeclinerCheckBox22 = Decliner:CreateCheckButton(260, -420, "Decline guild invites from RealID/Battletag friends")
	DeclinerCheckBox23 = Decliner:CreateCheckButton(340, -420, "Decline group invites from RealID/Battletag friends")
	DeclinerCheckBox24 = Decliner:CreateCheckButton(420, -420, "Decline petitions from RealID/Battletag friends")
	DeclinerCheckBox25 = Decliner:CreateCheckButton(500, -420, "Decline trades from RealID/Battletag friends")
	DeclinerText16 = Decliner:CreateText(18, -510, "Decliner:messages")
	DeclinerCheckBox26 = Decliner:CreateCheckButton(180, -500, "Hide Decliner:duel messages")
	DeclinerCheckBox27 = Decliner:CreateCheckButton(260, -500, "Hide Decliner:guild messages")
	DeclinerCheckBox28 = Decliner:CreateCheckButton(340, -500, "Hide Decliner:group messages")
	DeclinerCheckBox29 = Decliner:CreateCheckButton(420, -500, "Hide Decliner:petition messages")
	DeclinerCheckBox30 = Decliner:CreateCheckButton(500, -500, "Hide Decliner:trade messages")
	Decliner_Panel.refresh = function(self)
--		blockGIs = GetAutoDeclineGuildInvites()
--		blockTrades = GetCVar('blockTrades')
		Decliner:SetCheckBoxStates()
		declinervars.temp = declinervars.opt
	end
	Decliner_Panel.okay = function(self)
--		blockGIs = GetAutoDeclineGuildInvites()
--		blockTrades = GetCVar('blockTrades')
		Decliner:GetCheckBoxStates()
		declinersavedvars = declinervars.opt
		declinersavedvars.saved = true
	end
	Decliner_Panel.cancel = function(self)
		declinervars.opt = declinervars.temp
	end
	Decliner_Panel.default = function(self)
		Decliner:LoadDefaults()
	end
end

function Decliner:SetCheckBoxStates()
	DeclinerCheckBox01:SetChecked(declinervars.opt.duel.enabled)
	DeclinerCheckBox02:SetChecked(declinervars.opt.guild.enabled)
	DeclinerCheckBox03:SetChecked(declinervars.opt.group.enabled)
	DeclinerCheckBox04:SetChecked(declinervars.opt.chart.enabled)
	DeclinerCheckBox05:SetChecked(declinervars.opt.trade.enabled)
	DeclinerCheckBox06:SetChecked(declinervars.opt.duel.tell)
	DeclinerCheckBox07:SetChecked(declinervars.opt.guild.tell)
	DeclinerCheckBox08:SetChecked(declinervars.opt.group.tell)
	DeclinerCheckBox09:SetChecked(declinervars.opt.chart.tell)
	DeclinerCheckBox10:SetChecked(declinervars.opt.trade.tell)
	DeclinerCheckBox11:SetChecked(declinervars.opt.duel.guild)
	DeclinerCheckBox12:SetChecked(false)
	DeclinerCheckBox13:SetChecked(declinervars.opt.group.guild)
	DeclinerCheckBox14:SetChecked(declinervars.opt.chart.guild)
	DeclinerCheckBox15:SetChecked(declinervars.opt.trade.guild)
	DeclinerCheckBox16:SetChecked(declinervars.opt.duel.friend)
	DeclinerCheckBox17:SetChecked(declinervars.opt.guild.friend)
	DeclinerCheckBox18:SetChecked(declinervars.opt.group.friend)
	DeclinerCheckBox19:SetChecked(declinervars.opt.chart.friend)
	DeclinerCheckBox20:SetChecked(declinervars.opt.trade.friend)
	DeclinerCheckBox21:SetChecked(declinervars.opt.duel.bnet)
	DeclinerCheckBox22:SetChecked(declinervars.opt.guild.bnet)
	DeclinerCheckBox23:SetChecked(declinervars.opt.group.bnet)
	DeclinerCheckBox24:SetChecked(declinervars.opt.chart.bnet)
	DeclinerCheckBox25:SetChecked(declinervars.opt.trade.bnet)
	DeclinerCheckBox26:SetChecked(declinervars.opt.duel.message)
	DeclinerCheckBox27:SetChecked(declinervars.opt.guild.message)
	DeclinerCheckBox28:SetChecked(declinervars.opt.group.message)
	DeclinerCheckBox29:SetChecked(declinervars.opt.chart.message)
	DeclinerCheckBox30:SetChecked(declinervars.opt.trade.message)
	Decliner:DisableGT()
end

function Decliner:LoadDefaults()
	DeclinerCheckBox01:SetChecked(true)
	DeclinerCheckBox02:SetChecked(true)
	DeclinerCheckBox03:SetChecked(true)
	DeclinerCheckBox04:SetChecked(true)
	DeclinerCheckBox05:SetChecked(true)
	DeclinerCheckBox06:SetChecked(false)
	DeclinerCheckBox07:SetChecked(false)
	DeclinerCheckBox08:SetChecked(false)
	DeclinerCheckBox09:SetChecked(false)
	DeclinerCheckBox10:SetChecked(false)
	DeclinerCheckBox11:SetChecked(false)
	DeclinerCheckBox12:SetChecked(false)
	DeclinerCheckBox13:SetChecked(false)
	DeclinerCheckBox14:SetChecked(false)
	DeclinerCheckBox15:SetChecked(false)
	DeclinerCheckBox16:SetChecked(false)
	DeclinerCheckBox17:SetChecked(false)
	DeclinerCheckBox18:SetChecked(false)
	DeclinerCheckBox19:SetChecked(false)
	DeclinerCheckBox20:SetChecked(false)
	DeclinerCheckBox21:SetChecked(false)
	DeclinerCheckBox22:SetChecked(false)
	DeclinerCheckBox23:SetChecked(false)
	DeclinerCheckBox24:SetChecked(false)
	DeclinerCheckBox25:SetChecked(false)
	DeclinerCheckBox26:SetChecked(false)
	DeclinerCheckBox27:SetChecked(false)
	DeclinerCheckBox28:SetChecked(false)
	DeclinerCheckBox29:SetChecked(false)
	DeclinerCheckBox30:SetChecked(false)
	Decliner:GetCheckBoxStates()
end

function Decliner:GetCheckBoxStates()
	if DeclinerCheckBox01 ~= nil then declinervars.opt.duel.enabled = DeclinerCheckBox01:GetChecked() end
	if DeclinerCheckBox02 ~= nil then declinervars.opt.guild.enabled = DeclinerCheckBox02:GetChecked() end
	if DeclinerCheckBox03 ~= nil then declinervars.opt.group.enabled = DeclinerCheckBox03:GetChecked() end
	if DeclinerCheckBox04 ~= nil then declinervars.opt.chart.enabled = DeclinerCheckBox04:GetChecked() end
	if DeclinerCheckBox05 ~= nil then declinervars.opt.trade.enabled = DeclinerCheckBox05:GetChecked() end
	if DeclinerCheckBox06 ~= nil then declinervars.opt.duel.tell = DeclinerCheckBox06:GetChecked() end
	if DeclinerCheckBox07 ~= nil then declinervars.opt.guild.tell = DeclinerCheckBox07:GetChecked() end
	if DeclinerCheckBox08 ~= nil then declinervars.opt.group.tell = DeclinerCheckBox08:GetChecked() end
	if DeclinerCheckBox09 ~= nil then declinervars.opt.chart.tell = DeclinerCheckBox09:GetChecked() end
	if DeclinerCheckBox10 ~= nil then declinervars.opt.trade.tell = DeclinerCheckBox10:GetChecked() end
	if DeclinerCheckBox11 ~= nil then declinervars.opt.duel.guild = DeclinerCheckBox11:GetChecked() end
	if DeclinerCheckBox12 ~= nil then DeclinerCheckBox12:SetChecked(false) end
	if DeclinerCheckBox13 ~= nil then declinervars.opt.group.guild = DeclinerCheckBox13:GetChecked() end
	if DeclinerCheckBox14 ~= nil then declinervars.opt.chart.guild = DeclinerCheckBox14:GetChecked() end
	if DeclinerCheckBox15 ~= nil then declinervars.opt.trade.guild = DeclinerCheckBox15:GetChecked() end
	if DeclinerCheckBox16 ~= nil then declinervars.opt.duel.friend = DeclinerCheckBox16:GetChecked() end
	if DeclinerCheckBox17 ~= nil then declinervars.opt.guild.friend = DeclinerCheckBox17:GetChecked() end
	if DeclinerCheckBox18 ~= nil then declinervars.opt.group.friend = DeclinerCheckBox18:GetChecked() end
	if DeclinerCheckBox19 ~= nil then declinervars.opt.chart.friend = DeclinerCheckBox19:GetChecked() end
	if DeclinerCheckBox20 ~= nil then declinervars.opt.trade.friend = DeclinerCheckBox20:GetChecked() end
	if DeclinerCheckBox21 ~= nil then declinervars.opt.duel.bnet = DeclinerCheckBox21:GetChecked() end
	if DeclinerCheckBox22 ~= nil then declinervars.opt.guild.bnet = DeclinerCheckBox22:GetChecked() end
	if DeclinerCheckBox23 ~= nil then declinervars.opt.group.bnet = DeclinerCheckBox23:GetChecked() end
	if DeclinerCheckBox24 ~= nil then declinervars.opt.chart.bnet = DeclinerCheckBox24:GetChecked() end
	if DeclinerCheckBox25 ~= nil then declinervars.opt.trade.bnet = DeclinerCheckBox25:GetChecked() end
	if DeclinerCheckBox26 ~= nil then declinervars.opt.duel.message = DeclinerCheckBox26:GetChecked() end
	if DeclinerCheckBox27 ~= nil then declinervars.opt.guild.message = DeclinerCheckBox27:GetChecked() end
	if DeclinerCheckBox28 ~= nil then declinervars.opt.group.message = DeclinerCheckBox28:GetChecked() end
	if DeclinerCheckBox29 ~= nil then declinervars.opt.chart.message = DeclinerCheckBox29:GetChecked() end
	if DeclinerCheckBox30 ~= nil then declinervars.opt.trade.message = DeclinerCheckBox30:GetChecked() end
	Decliner:DisableGT()
end

function Decliner:DisableGT()
	if declinervars.opt.guild.enabled then
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText("|cff666666"..BLOCK_GUILD_INVITES.." (Decliner)")
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Disable()
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockGuildInvitesText']:SetText(BLOCK_GUILD_INVITES)
		_G['InterfaceOptionsControlsPanelBlockGuildInvites']:Enable()
--		SetAutoDeclineGuildInvites(blockGIs)
	end
	if declinervars.opt.trade.enabled then
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText("|cff666666"..BLOCK_TRADES.." (Decliner)")
		_G['InterfaceOptionsControlsPanelBlockTrades']:Disable()
		_G['InterfaceOptionsControlsPanelBlockTrades']:SetChecked(false)
	else
		_G['InterfaceOptionsControlsPanelBlockTradesText']:SetText(BLOCK_TRADES)
		_G['InterfaceOptionsControlsPanelBlockTrades']:Enable()
--		SetCVar('blockTrades', blockTrades)
	end
end

SLASH_DECLINER1 = '/decliner'
SLASH_DECLINER2 = '/decline'
SLASH_DECLINER3 = '/dcl'
function SlashCmdList:DECLINER() InterfaceOptionsFrame_OpenToCategory('Decliner') end

-- below code pasted from http://www.curse.com/addons/wow/blizzbugssuck
-- Fix InterfaceOptionsFrame_OpenToCategory not actually opening the category (and not even scrolling to it)
-- Confirmed still broken in 6.0.3.19243
-- Decliner note: still broken in 6.2.0.20253 as of July 24th, 2015
do
	local function get_panel_name(panel)
		local tp = type(panel)
		local cat = INTERFACEOPTIONS_ADDONCATEGORIES
		if tp == 'string' then
			for i = 1, #cat do
				local p = cat[i]
				if p.name == panel then
					if p.parent then
						return get_panel_name(p.parent)
					else
						return panel
					end
				end
			end
		elseif tp == 'table' then
			for i = 1, #cat do
				local p = cat[i]
				if p == panel then
					if p.parent then
						return get_panel_name(p.parent)
					else
						return panel.name
					end
				end
			end
		end
	end

	local function InterfaceOptionsFrame_OpenToCategory_Fix(panel)
		if doNotRun or InCombatLockdown() then return end
		local panelName = get_panel_name(panel)
		if not panelName then return end -- if its not part of our list return early
		local noncollapsedHeaders = {}
		local shownpanels = 0
		local mypanel
		local t = {}
		local cat = INTERFACEOPTIONS_ADDONCATEGORIES
		for i = 1, #cat do
			local panel = cat[i]
			if not panel.parent or noncollapsedHeaders[panel.parent] then
				if panel.name == panelName then
					panel.collapsed = true
					t.element = panel
					InterfaceOptionsListButton_ToggleSubCategories(t)
					noncollapsedHeaders[panel.name] = true
					mypanel = shownpanels + 1
				end
				if not panel.collapsed then
					noncollapsedHeaders[panel.name] = true
				end
				shownpanels = shownpanels + 1
			end
		end
		local Smin, Smax = InterfaceOptionsFrameAddOnsListScrollBar:GetMinMaxValues()
		if shownpanels > 15 and Smin < Smax then
			local val = (Smax/(shownpanels-15))*(mypanel-2)
			InterfaceOptionsFrameAddOnsListScrollBar:SetValue(val)
		end
		doNotRun = true
		InterfaceOptionsFrame_OpenToCategory(panel)
		doNotRun = false
	end

	hooksecurefunc('InterfaceOptionsFrame_OpenToCategory', InterfaceOptionsFrame_OpenToCategory_Fix)
end